/* *****************************************************************
 *
 *  $Id: f0s_getdelim.h,v 1.1.1.1 2002/04/28 22:06:51 jml Exp $
 *
 *  Copywright (c) 1999 by Joao Lourenco <Joao.Lourenco@di.fct.unl.pt>
 *  Time-stamp: <99/05/27 21:24:12 jml>
 *
 *  Universidade Nova de Lisboa
 *  Faculdade de Ciencias e Tecnologia
 *  Departamento de Informatica
 *  Parallel and Distributed Processing Group
 *
 * -----------------------------------------------------------------
 *
 *  Description:
 *
 * -----------------------------------------------------------------
 */
#ifndef __F0_GETDELIM_H
#define __F0_GETDELIM_H


/* -----------------------------------------------------------------
 * Function:    char *get_delim (IN FILE *fd, IN const char *delim)
 *
 * Description: Read chars from 'fd' until 'delim' is read.
 *				'delim' is not included in the string read.
 *
 * Returns:     Pointer to dynamically allocated string.
 *				The user should 'free()' the string when no longer needed.
 */
char *get_delim (FILE *fd, const char *delim);


#endif /* __F0_GETDELIM_H */
