/* *****************************************************************
 *
 *  $Id: f0s_tkout.h,v 1.4 2002/08/12 00:29:35 jml Exp $
 *
 *  Copyright (c) 1999 by Dep.Informatica of the FCT/UNL
 *  Time-stamp: <02/08/09 22:23:15 jml>
 *
 *  Joao Lourenco <Joao.Lourenco@di.fct.unl.pt>
 *
 *  Parallel and Distributed Processing Group
 *  Departamento de Informatica
 *  Faculdade de Ciencias e Tecnologia
 *  Universidade Nova de Lisboa
 *
 * -----------------------------------------------------------------
 *
 *  Description:
 *
 * -----------------------------------------------------------------
 */
#ifndef __F0_TKOUT_H
#define __F0_TKOUT_H

#include "chain.h"
#include "f0s_out_codes.h"


/* #################################################################
 *      One structure for each possible 'rep_outcode'
 * ################################################################# */

/* start_RTIDS */
typedef struct rtids_s {
    int			   gtid;
    int			   ltid;		/* = -1 in f0s & f0m */
	char		  *machine;		/* NULL int f0s & f0m */
    int			   tp_pid;
    int			   dbg_pid;
    int			   attached;
} rtids_t;
/* end_RTIDS */

/* start_RKILL */
typedef struct rkill_s {
} rkill_t;
/* end_RKILL */

/* start_RADDDEBUGGER */
typedef struct radddebugger_s {
    int tid;
} radddebugger_t;
/* end_RADDDEBUGGER */

/* start_RATTACH */
typedef struct rattach_s {
    int			   tid;
    int			   tp_pid;
} rattach_t;
/* end_RATTACH */

/* start_RDETACH */
typedef struct rdetach_s {
    int			   tp_pid;
} rdetach_t;
/* end_RDETACH */

/* start_RSYMBOLFILE */
typedef struct rsymbolfile_s {
/*     const char    *file; */
} rsymbolfile_t;
/* end_RSYMBOLFILE */

/* start_RFILE */
typedef struct rfile_s {
    int tid;
/*     const char    *file; */
} rfile_t;
/* end_RFILE */

/* start_RRUN */
typedef struct rrun_s {
    const char    *file;
} rrun_t;
/* end_RRUN */

/* start_RSTEP */
typedef struct rstep_s {
} rstep_t;
/* end_RSTEP */

/* start_RNEXT */
typedef struct rnext_s {
} rnext_t;
/* end_RNEXT */

/* start_RCONTINUE */
typedef struct rcontinue_s {
} rcontinue_t;
/* end_RCONTINUE */

/* start_RFINISH */
typedef struct rfinish_s {
    const void    *s_address;
    const char    *s_function;
    const char    *s_args;
    const char    *s_file;
    int            s_line;
    int            dbg_var;
    const char    *value;
} rfinish_t;
/* end_RFINISH */

/* start_RBREAK */
typedef struct rbreak_s {
    int            bpid;
    const void    *address;
    const char    *file;
    int            line;
} rbreak_t;
/* end_RBREAK */

/* start_RDELETE */
typedef struct rdelete_s {
} rdelete_t;
/* end_RDELETE */

/* start_RSETVARIABLE */
typedef struct rsetvariable_s {
} rsetvariable_t;
/* end_RSETVARIABLE */

/* start_REVALUATE */
typedef struct revaluate_s {
    int            dbg_var;
    const char    *value;
} revaluate_t;
/* end_REVALUATE */

/* start_RINFOLOCALS */
typedef struct rinfolocals_s {
    const char    *var;
    const char    *value;
} rinfolocals_t;
/* end_RINFOLOCALS */

/* start_RDISPLAY */
typedef struct rdisplay_s {
    int            dispid;
    int            enabled;
    const char    *expression;
    const char    *value;
} rdisplay_t;
/* end_RDISPLAY */

/* start_RUNDISPLAY */
typedef struct rundisplay_s {
} rundisplay_t;
/* end_RUNDISPLAY */

/* start_RLIST */
typedef struct rlist_s {
    int            line_number;
    const char    *line_text;
} rlist_t;
/* end_RLIST */

/* start_RINFOLINE */
typedef struct rinfoline_s {
    int            line;
    const char    *file;
    const char    *start_function;
    int            start_function_offset;
    const char    *end_function;
    int            end_function_offset;
    const void    *start_address;
    const void    *end_address;
} rinfoline_t;
/* end_RINFOLINE */

/* start_RINFOPROGRAM */
typedef struct rinfoprogram_s {
    int            tp_pid;
    const void    *address;
    const char    *why;
    int            bpid;
    const char    *signal;
} rinfoprogram_t;
/* end_RINFOPROGRAM */


/* start_RINFOSTACK */
typedef struct rframe_s {
    int            frame;
    const void    *address;
    const char    *function;
    const char    *arguments;
    const char    *file;
    int            line;
} rframe_t;
/* end_RINFOSTACK */


/* start_RINFOBREAK */
typedef struct rinfobreak_s {
    int            bpid;
    const char    *type;
    const char    *disp;
    int            enabled;
    const void    *address;
    const char    *function;
    const char    *file;
    int            line;
    int            hit_counter;
    int            ign_counter;
    const char    *condition;
} rinfobreak_t;
/* end_RINFOBREAK */

/* start_RINFODISPLAY */
/* Uses "frame_t" structure */
/* end_RINFODISPLAY */

/* start_RINFOTHREADS */
typedef struct rinfothreads_s {
    int            active;
    int            th_id;
    int            tp_pid;
    const void    *frame;
    const char	  *function;
    const char	  *arguments;
    const char	  *file;
    int            line;
} rinfothreads_t;
/* end_RINFOTHREADS */

/* start_RTTY */
typedef struct rtty_s {
} rtty_t;
/* end_RTTY */

/* start_RSENDTO */
typedef struct rsendto_s {
    const char    *output;
} rsendto_t;
/* end_RSENDTO */

/* start_RCLIENTS */
typedef struct rclients_s {
	int			pid;
    const char *filename;
	const char *hostaddr;
} rclients_t;
/* end_RCLIENTS */




/* #################################################################
 *      One structure for each possible 'oob_outcode'
 * ################################################################# */
typedef rdisplay_t odisplay_t;

/* start_OBPHIT */
typedef struct obphit_s {
    int            bpid;
    const char    *function;
    const char    *args;
    const char    *file;
    int            line;
} obphit_t;
/* end_OBPHIT */

/* start_OSIGNAL */
typedef struct osignal_s {
    const char    *name;
} osignal_t;
/* end_OSIGNAL */

/* start_ONEWTHREAD */
typedef struct onewthread_s {
    int            id;
} onewthread_t;
/* end_ONEWTHREAD */

/* start_OTHREAD */
typedef struct othread_s {
    int            pid;
} othread_t;
/* end_OTHREAD */





/* #################################################################
 *      One structure for each possible 'pos_outcode'
 * ################################################################# */

/* start_PPOSITION */
typedef struct pposition_s {
    const char    *file;
    int            line;
    int            pos;
    const char    *where;
    const void    *frame;
} pposition_t;
/* end_PPOSITION */



/* #################################################################
 *      One structure for all 'output data'
 * ################################################################# */

/* start_DATA */
typedef struct data_s {
    code_t         code;		/* The ERROR code */
    const char    *str;			/* The relevant part of the output */
    chain_t       *data;		/* The data extrated from the output */
} data_t;
/* end_DATA */



/* #################################################################
 *      The Output Token - level 0
 * ################################################################# */

/* start_TKOUT */
typedef struct tkout_s {
	/* int			 reqid; */			/* The request ID */
	int			 tid;			/* The TID of the requester */
    code_t       status;		/* The status of the request */
    const char  *str;			/* The ourput of the CLD */
    data_t      *rep;			/* The reply (when successful) */
    chain_t     *oob;			/* The out-of-band data (when successful) */
    data_t      *pos;			/* The current position in the source
								   code. Not always available. */
    data_t      *err;			/* The error data (when unsuccessful) */
} tkout_t;
/* end_TKOUT */



/* #################################################################
 *      Create and Destroy Output Tokens
 * ################################################################# */


/* -----------------------------------------------------------------
 * Function:    f0s_tkout_data_new()
 *
 * Description: Create a new empty Data for the Output Token.
 *
 * Returns:     Pointer to the allocated memory area.
 */
data_t *f0s_tkout_data_new (void);


/* -----------------------------------------------------------------
 * Function:    f0s_tkout_data_delete_2()
 *
 * Description: Delete a Data in the Output Token.
 *
 * Returns:     Status
 */
#define f0s_tkout_data_delete(data) f0s_tkout_data_delete_2(data,NULL)

int f0s_tkout_data_delete_2 (void *obj, void *args);


/* -----------------------------------------------------------------
 * Function:    f0s_tkout_oob_delete()
 *
 * Description: Delete a Oob in the Output Token.
 *
 * Returns:     Status
 */
int f0s_tkout_oob_delete (chain_t *oob);


/* -----------------------------------------------------------------
 * Function:    f0s_tkout_new()
 *
 * Description: Create a new empty Output Token.
 *
 * Returns:     Pointer to the allocated token.
 */
tkout_t *f0s_tkout_new (code_t status);


/* -----------------------------------------------------------------
 * Function:    f0s_tkout_delete()
 *
 * Description: Free all the 'strings' in the token and then free the
 *                  token's memory
 *
 * Returns:     The status
 */
int f0s_tkout_delete (tkout_t *t);


#endif /* __F0_TKOUT_H */
