/* ******************************************************************
 *
 *  Teste.java
 *
 *  Copyright (c) 2001 by Dep.Informatica of the FCT/UNL
 *  Time-stamp: <02/07/24 15:38:24 rja>
 *
 *  Ricardo Anastacio [jml] <rja@asc.di.fct.unl.pt>
 *
 *  Parallel and Distributed Processing Group
 *  Departamento de Informatica
 *  Faculdade de Ciencias e Tecnologia
 *  Universidade Nova de Lisboa
 *
 * -----------------------------------------------------------------
 *
 *  Description:
 *
 * -----------------------------------------------------------------
 */

import java.io.*;

public class Teste {
	 Fiddle_j f;
	 private OoB_walker oobwalker;
    private Pos_walker posw;


	 public Teste() {
		  super();
		  try {
				f = new Fiddle_j();
		  } catch (FiddleNotInitializedException e) {
				System.err.println("O fiddle no inicializou.\nO construtor do Fiddle_j retornou a seguinte mensagem numa excepo FiddleNotInitializedException:");
				System.err.println(e.getMessage());
				System.err.println("\nAbortando a execuo!");
				System.exit(-1);
		  }

		  oobwalker = new OoB_walker();
		  posw = new Pos_walker();
	 }

	 public void menu() {
		  System.out.print("\n\n\nMenu:\n\tf) carregar um novo executvel (file)");
		  System.out.print("\n\tb1) definir um novo breakpoint numa linha do ficheiro corrente (break)");
		  System.out.print("\n\tb2) definir um novo breakpoint numa funo do ficheiro corrente (break)");
		  System.out.print("\n\td) apagar um breakpoint (delete)");
		  System.out.print("\n\tr) comear a execuo do executvel carregado (run)");
		  System.out.print("\n\tc) continuar a execuo do executvel (continue)");
		  System.out.print("\n\tl) listar o cdigo-fonte (list)");
		  System.out.print("\n\tt) mostrar os Task IDs dos vrios processos (tids)");
		  System.out.print("\n\ta) carregar um ficheiro j em execuo (attach)");
		  System.out.print("\n\ts) executar apenas uma instruo (step)");
		  System.out.print("\n\tn) saltar para a poxima instruo (next)");
		  System.out.print("\n\tfi) finalizar esta stack frame (finish)");
		  System.out.print("\n\tsendto) Enviar um comando directamente ao debugger associado (sendto)");
		  System.out.print("\n\tq) sair\n\n--> ");
	 }

	 public void showFile(Tkout_j tk) {
		  System.out.println("Fim do file. Contedo do tkout_t relevante:");
		  System.out.println("tid:"+tk.tid);
		  System.out.println("str:"+tk.str);
		  System.out.println("status:"+tk.status+"\n");
		  System.out.println("rep:code:value:"+tk.rep.code.value);
		  try {
				System.out.println("rep:code:value message:"+tk.rep.code.getMessage()+"\n");
		  } catch (UnknownCodeException uce) {}
		  if(tk.OoB.length() != 0) {
				System.out.println("OoB:");
				tk.OoB.walk(oobwalker,null);
		  }
	 }
  
	 public void showBP(Tkout_j tk) {
		  BP_walker bpw = new BP_walker();
		  
		  System.out.println("Fim do setBreakpoint. Contedo do tkout_t relevante:");
		  System.out.println("tid:"+tk.tid);
		  System.out.println("str:"+tk.str);
		  System.out.println("status:"+tk.status+"\n");
		  System.out.println("rep:str"+tk.rep.str);
		  System.out.println("rep:code:value:"+tk.rep.code.value);
		  try {
				System.out.println("rep:code:value message:"+tk.rep.code.getMessage());
		  } catch (UnknownCodeException uce) {}
		  tk.rep.data.walk(bpw,null);
		  if(tk.OoB.length() != 0) {
				System.out.println("OoB:");
				tk.OoB.walk(oobwalker,null);
		  }

	 }


	 public void showRun(Tkout_j tk) {
		  System.out.println("Fim do Run. Contedo do tkout_t relevante:");
		  System.out.println("tid:"+tk.tid);
		  System.out.println("str:"+tk.str);
		  System.out.println("status:"+tk.status+"\n");
		  if(tk.OoB.length() != 0) {
				System.out.println("OoB:");
				tk.OoB.walk(oobwalker,null);
				System.out.println("\n");
		  }
		  if(tk.rep.code.value != Code_j.FIDDLE_OK) {
				System.out.println("rep:str"+tk.rep.str);
				System.out.println("rep:code:value:"+tk.rep.code.value);
				try {
					 System.out.println("rep:code:value message:"+tk.rep.code.getMessage());
				} catch (UnknownCodeException uce) {}
				System.out.println("\n");
		  }
		  if(tk.pos.data.length() != 0) {
				System.out.println("pos:str"+tk.pos.str);
				System.out.println("pos:code:value:"+tk.pos.code.value);
				try {
					 System.out.println("rep:code:value message:"+tk.pos.code.getMessage());
				} catch (UnknownCodeException uce) {}
				tk.pos.data.walk(posw,null);
		  }
	 }

	 public void showCont(Tkout_j tk) {
		  System.out.println("Fim do Continue. Contedo do tkout_t relevante:");
		  System.out.println("tid:"+tk.tid);
		  System.out.println("str:"+tk.str);
		  System.out.println("status:"+tk.status+"\n");
		  if(tk.OoB.length() != 0) {
				System.out.println("OoB:");
				tk.OoB.walk(oobwalker,null);
				System.out.println("\n");
		  }
		  if(tk.rep.code.value != Code_j.FIDDLE_OK) {
				System.out.println("rep:str"+tk.rep.str);
				System.out.println("rep:code:value:"+tk.rep.code.value);
				try {
					 System.out.println("rep:code:value message:"+tk.rep.code.getMessage());
				} catch (UnknownCodeException uce) {}
				System.out.println("\n");
		  }
		  if(tk.pos.data.length() != 0) {
				System.out.println("pos:str:"+tk.pos.str);
				System.out.println("pos:code:value:"+tk.pos.code.value);
				try {
					 System.out.println("rep:code:value message:"+tk.pos.code.getMessage());
				} catch (UnknownCodeException uce) {}
				tk.pos.data.walk(posw,null);
		  }
	 }


	 public void showDelete(Tkout_j tk) {
		  System.out.println("Fim do Delete. Contedo do tkout_t relevante:");
		  System.out.println("tid:"+tk.tid);
		  System.out.println("str:"+tk.str);
		  System.out.println("status:"+tk.status+"\n");
		  if(tk.OoB.length() != 0) {
				System.out.println("OoB:");
				tk.OoB.walk(oobwalker,null);
				System.out.println("\n");
		  }
		  if(tk.rep.code.value != Code_j.FIDDLE_OK) {
				System.out.println("rep:str"+tk.rep.str);
				System.out.println("rep:code:value:"+tk.rep.code.value);
				try {
					 System.out.println("rep:code:value message:"+tk.rep.code.getMessage());
				} catch (UnknownCodeException uce) {}
				System.out.println("\n");
		  }
		  if(tk.pos.data.length() != 0) {
				System.out.println("pos:str"+tk.pos.str);
				System.out.println("pos:code:value:"+tk.pos.code.value);
				try {
					 System.out.println("rep:code:value message:"+tk.pos.code.getMessage());
				} catch (UnknownCodeException uce) {}
				tk.pos.data.walk(posw,null);
		  }
	 }



	 public void showList(Tkout_j tk) {
		  List_walker lw = new List_walker();

		  System.out.println("Fim do Delete. Contedo do tkout_t relevante:");
		  System.out.println("tid:"+tk.tid);
		  System.out.println("str:"+tk.str);
		  System.out.println("status:"+tk.status+"\n");
		  if(tk.OoB.length() != 0) {
				System.out.println("OoB:");
				tk.OoB.walk(oobwalker,null);
				System.out.println("\n");
		  }
		  if(tk.rep.data.length() != 0) {
				System.out.println("rep:str:"+tk.rep.str);
				System.out.println("rep:code:value:"+tk.rep.code.value);
				try {
					 System.out.println("rep:code:value message:"+tk.rep.code.getMessage());
				} catch (UnknownCodeException uce) {}
				tk.rep.data.walk(lw,null);
				System.out.println("\n");
		  }
		  if(tk.pos.data.length() != 0) {
				System.out.println("pos:str"+tk.pos.str);
				System.out.println("pos:code:value:"+tk.pos.code.value);
				try {
					 System.out.println("rep:code:value message:"+tk.pos.code.getMessage());
				} catch (UnknownCodeException uce) {}
				tk.pos.data.walk(posw,null);
		  }
	 }



  public static void main(String[] args) {
	 byte[] b = new byte[255];
	 Teste t = new Teste();
	 boolean exit = false;
	 String str1 = "Infinito", str2 = "localhost", cmd;
	 Tkout_j tk;
	 int n, start_line=1, n_lines=10, tid = 0;

	 while(!exit) {
		  try {
				t.menu();
				n = System.in.read(b);
				cmd = new String(b, 0, n-1);
				if(cmd.compareToIgnoreCase("f") == 0) {
					 System.out.print("Nome do executvel ["+str1+"]: ");
					 n = System.in.read(b);
					 if(n!=1) str1 = new String(b, 0, n-1);
					 System.out.print("Nome da mquina ["+str2+"]: ");
					 n = System.in.read(b);
					 if(n!=1) str2 = new String(b, 0, n-1);
					 tk = t.f.file(str2, str1);
//					 System.out.println("\nFim do file. Contedo do tkout:\n" + tk);
					 t.showFile(tk);
					 tid = tk.tid;
					 tk = null;
				} else if(cmd.compareToIgnoreCase("b1") == 0) {
					 System.out.print("Task ID do ficheiro ["+tid+"]: ");
					 n = System.in.read(b);
					 if(n!=1) tid = new Integer(new String(b,0,n-1)).intValue();
					 System.out.print("Nmero da linha a parar: ");
					 n = System.in.read(b);
					 tk = t.f.setBreakpoint(tid, null, new Integer(new String(b,0,n-1)).intValue(), null);
//					 System.out.println("\nFim do setBreakpoint. Contedo do tkout:\n" + tk);
					 t.showBP(tk);
					 tk = null;
				} else if(cmd.compareToIgnoreCase("b2") == 0) {
					 System.out.print("Task ID do ficheiro ["+tid+"]: ");
					 n = System.in.read(b);
					 if(n!=1) tid = new Integer(new String(b,0,n-1)).intValue();
					 System.out.print("Nome da funo a parar: ");
					 n = System.in.read(b);
					 tk = t.f.setBreakpoint(tid, null, -1, new String(b, 0, n-1));
//					 System.out.println("\nFim do setBreakpoint. Contedo do tkout:\n" + tk);
					 t.showBP(tk);
					 tk = null;
				} else if(cmd.compareToIgnoreCase("d") == 0) {
					 System.out.print("Task ID do ficheiro ["+tid+"]: ");
					 n = System.in.read(b);
					 if(n!=1) tid = new Integer(new String(b,0,n-1)).intValue();
					 System.out.print("ID do breakpoint: ");
					 n = System.in.read(b);
					 tk = t.f.delete(tid, new Integer(new String(b,0,n-1)).intValue());
//					 System.out.println("\nFim do setBreakpoint. Contedo do tkout:\n" + tk);
					 t.showDelete(tk);
					 tk = null;
				} else if(cmd.compareToIgnoreCase("r") == 0) {
					 System.out.print("Task ID do ficheiro ["+tid+"]: ");
					 n = System.in.read(b);
					 if(n!=1) tid = new Integer(new String(b,0,n-1)).intValue();
					 tk = t.f.run(tid, null);
//					 System.out.println("\nFim do run. Contedo do tkout:\n" + tk);
					 t.showRun(tk);
					 tk = null;
				} else if(cmd.compareToIgnoreCase("c") == 0) {
					 System.out.print("Task ID do ficheiro ["+tid+"]: ");
					 n = System.in.read(b);
					 if(n!=1) tid = new Integer(new String(b,0,n-1)).intValue();
					 tk = t.f.continueExecution(tid);
//					 System.out.println("\nFim do continue. Contedo do tkout:\n" + tk);
					 t.showCont(tk);
					 tk = null;
				} else if(cmd.compareToIgnoreCase("l") == 0) {
					 System.out.print("Task ID do ficheiro ["+tid+"]: ");
					 n = System.in.read(b);
					 if(n!=1) tid = new Integer(new String(b,0,n-1)).intValue();
					 System.out.print("Nome do ficheiro com o cdigo-fonte [corrente]: ");
					 n = System.in.read(b);
					 if(n!=1) str1 = new String(b,0,n-1);
					 else str1 = null;
					 System.out.print("Linha de inicio ["+start_line+"]: ");
					 n = System.in.read(b);
					 if(n!=1) start_line = new Integer(new String(b,0,n-1)).intValue();
					 if(start_line==-1) {
						System.out.print("Nome da funo a listar: ");
						n = System.in.read(b);
						str2 = new String(b,0,n-1);
					 }	else str2 = null;
					 System.out.print("Nmero de linhas a listar ["+n_lines+"]: ");
					 n = System.in.read(b);
					 if(n!=1) n_lines = new Integer(new String(b,0,n-1)).intValue();
					 tk = t.f.list(tid, str1, start_line, str2, n_lines);
//					 System.out.println("\nFim do continue. Contedo do tkout:\n" + tk);
					 t.showList(tk);
					 tk = null;
				} else if(cmd.compareToIgnoreCase("t") == 0) {
					 tk = t.f.tids();
					 System.out.println("\nFim do Tids. Contedo do tkout:\n" + tk.rep);
//					 t.showCont(tk);
					 tk = null;
				} else if(cmd.compareToIgnoreCase("a") == 0) {
					 System.out.print("Nome da mquina [localhost]: ");
					 n = System.in.read(b);
					 if(n!=1) str1 = new String(b,0,n-1); else str1 = "localhost";
					 System.out.print("PID do processo: ");
					 n = System.in.read(b);
					 tk = t.f.attach(str1, new Integer(new String(b,0,n-1)).intValue());
					 System.out.println("\nFim do attach. Contedo do tkout:\n" + tk);
//					 t.showCont(tk);
					 tk = null;
				} else if(cmd.compareToIgnoreCase("s") == 0) {
					 System.out.print("Task ID do ficheiro ["+tid+"]: ");
					 n = System.in.read(b);
					 if(n!=1) tid = new Integer(new String(b,0,n-1)).intValue();
					 tk = t.f.step(tid);
					 System.out.println("\nFim do step. Contedo do tkout:\n" + tk);
//					 t.showDelete(tk);
					 tk = null;
				} else if(cmd.compareToIgnoreCase("n") == 0) {
					 System.out.print("Task ID do ficheiro ["+tid+"]: ");
					 n = System.in.read(b);
					 if(n!=1) tid = new Integer(new String(b,0,n-1)).intValue();
					 tk = t.f.next(tid);
					 System.out.println("\nFim do next. Contedo do tkout:\n" + tk);
//					 t.showDelete(tk);
					 tk = null;
				} else if(cmd.compareToIgnoreCase("fi") == 0) {
					 System.out.print("Task ID do ficheiro ["+tid+"]: ");
					 n = System.in.read(b);
					 if(n!=1) tid = new Integer(new String(b,0,n-1)).intValue();
					 tk = t.f.finish(tid);
					 System.out.println("\nFim do finish. Contedo do tkout:\n" + tk);
//					 t.showDelete(tk);
					 tk = null;
				} else if(cmd.compareToIgnoreCase("sendto") == 0) {
					 System.out.print("Task ID do ficheiro ["+tid+"]: ");
					 n = System.in.read(b);
					 if(n!=1) tid = new Integer(new String(b,0,n-1)).intValue();
					 System.out.print("Comando: ");
					 n = System.in.read(b);
					 tk = t.f.sendto(tid, new String(b,0,n-1));
					 System.out.println("\nFim do sendto. Contedo do tkout:\n" + tk);
//					 t.showDelete(tk);
					 tk = null;
				} else if(cmd.compareToIgnoreCase("q") == 0) {
				    t.f = null; t = null;
					 System.gc();
					 exit=true;
					 break;
				} else {
					 System.out.println("Opo invlida! Tente novamente.");
				}

		  } catch (IOException ioe) {
				System.err.println("No foi possivel ler quaisquer dados.\nExcepo:"+ioe.getMessage());
		  } catch (TkoutException tke) {
				System.err.println("Erro na criao do Tkout: "+tke.getMessage() );
				System.err.println("                   str = \""+tke.str+"\"");
				try {
					 System.err.println("                   code = "+tke.code.value+", "+tke.code.getMessage());
					 System.err.println("                   status = "+tke.status.value+", "+tke.status.getMessage());
				} catch (UnknownCodeException uce) {}
		  } catch (NullPointerException npe) {
				System.err.println("Erro com um NullPointerException:" + npe.getMessage() );
//		  } catch (Exception e) {
//				System.err.println("Erro com uma Exception:"+e.getMessage());
		  }

		  System.gc();
	 }

	 System.out.println("\nSaindo do programa de teste.\nObrigado por testar o fiddle_j.\n");
  }



}
