/* ******************************************************************
 *
 *  $Id: Tkout_j.java,v 1.1 2002/08/31 15:23:00 rja Exp $
 *
 *  Copyright (c) 2000 by Dep.Informatica of the FCT/UNL
 *  Time-stamp: <02/08/22 15:08:58 rja>
 *
 *  Ricardo Anastacio [jml] <rja@asc.di.fct.unl.pt>
 *
 *  Parallel and Distributed Processing Group
 *  Departamento de Informatica
 *  Faculdade de Ciencias e Tecnologia
 *  Universidade Nova de Lisboa
 *
 * -----------------------------------------------------------------
 *
 *  Description:
 *
 * Class Tkout_j is the blueprint of the java object that will 
 * represent C's tkout variable.
 * There should be a new Tkout_j returned for each fiddle lib call.
 *
 * -----------------------------------------------------------------
 */

package unl.fct.di.fiddle_j;

import unl.fct.di.fiddle_j.util.*;


public class Tkout_j {

  public int tid;
  public String str;
  public Code_j status;
  public Chain_j OoB;
  public Data_j rep;
  public Data_j pos;
  /* Private, Protected or public? */ boolean err_chk;
  // RIC: If err_chk == true then the JNI functions do the error checking and Out of Band checking throwing exceptions if that are the cases, else JNI functions won't do any checking...
  private Chain_walker OoBwalker;
  
  public Tkout_j() {
	 super();
	 
	 tid = 0;
	 str = new String();
	 status = new Code_j(Code_j.FIDDLE_OK);
	 OoB = new Chain_j();
	 rep = new Data_j();
	 pos = new Data_j();
  }
  
  public Tkout_j(int tid_arg, String str_arg, Code_j status_arg, Chain_j OoB_arg, Data_j rep_arg, Data_j pos_arg) {
		tid = tid_arg;
		if(str_arg==null) str = new String();
		else str = new String(str_arg);
		if(status_arg==null) status = new Code_j(Code_j.FIDDLE_OK);
		else status = new Code_j(status_arg);
		if(OoB_arg==null) OoB = new Chain_j();
		else OoB = new Chain_j(OoB_arg);
		if(rep_arg==null) rep = new Data_j();
		else rep = new Data_j(rep_arg);
		if(pos_arg==null) pos = new Data_j();
		else pos = new Data_j(pos_arg);
  }
  
  public Tkout_j(Tkout_j t) {
	 tid = t.tid;
	 str = new String(t.str);
	 status = new Code_j(t.status);
	 OoB = new Chain_j(t.OoB);
	 rep = new Data_j(t.rep);
	 pos = new Data_j(t.pos);
  }
  
  public String toString() {
	 StringBuffer aux = new StringBuffer();
	 aux.append("Tkout object contents\n\ttid:").append(tid);
	 aux.append("\n\n\tstr:"). append(str);
	 aux.append("\n\n\tstatus:").append(status.toString());
	 aux.append("\n\n\tOoB:").append(OoB.toString());
	 aux.append("\n\n\trep:").append(rep.toString());
	 aux.append("\n\n\tpos:").append(pos.toString());
	 aux.append("\n");

	 return new String(aux);
  }
}
