/* *****************************************************************
 *
 *  $Id: common.h,v 1.1 2002/08/31 15:23:00 rja Exp $
 *
 *  Copyright (c) 2001 by Dep.Informatica of the FCT/UNL
 *  Time-stamp: <02/08/26 12:40:47 rja>
 *
 *  Ricardo Anastacio [jml] <rja@asc.di.fct.unl.pt>
 *
 *  Parallel and Distributed Processing Group
 *  Departamento de Informatica
 *  Faculdade de Ciencias e Tecnologia
 *  Universidade Nova de Lisboa
 *  
 * -----------------------------------------------------------------
 *
 *  Description:
 *
 * -----------------------------------------------------------------
 */
#ifndef __COMMON_H_
#define __COMMON_H_

#include <jni.h>
#include <fiddle/fiddle1m.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define PRIVATE static
#define PUBLIC

#define MAX_STR 150

#ifdef with_packages

#define ATTACH_J_SIG "Lunl/fct/di/fiddle_j/Attach_j;"
#define BPHIT_J_SIG "Lunl/fct/di/fiddle_j/Bphit_j;"
#define BREAK_J_SIG "Lunl/fct/di/fiddle_j/Break_j;"
#define CLIENTS_J_SIG "Lunl/fct/di/fiddle_j/Clients_j;"
#define CODE_J_SIG  "Lunl/fct/di/fiddle_j/Code_j;"
#define DATA_J_SIG "Lunl/fct/di/fiddle_j/Data_j;"
#define DETACH_J_SIG "Lunl/fct/di/fiddle_j/Detach_j;"
#define DISPLAY_J_SIG "Lunl/fct/di/fiddle_j/Display_j;"
#define EVALUATE_J_SIG "Lunl/fct/di/fiddle_j/Evaluate_j;"
#define FRAME_J_SIG "Lunl/fct/di/fiddle_j/Frame_j;"
#define FILE_J_SIG "Lunl/fct/di/fiddle_j/File_j;"
#define FINISH_J_SIG "Lunl/fct/di/fiddle_j/Finish_j;"
#define INFOBREAK_J_SIG "Lunl/fct/di/fiddle_j/Infobreak_j;"
#define INFOLINE_J_SIG "Lunl/fct/di/fiddle_j/Infoline_j;"
#define INFOPROGRAM_J_SIG "Lunl/fct/di/fiddle_j/Infoprogram_j;"
#define INFOTHREADS_J_SIG "Lunl/fct/di/fiddle_j/Infothreads_j;"
#define LIST_J_SIG "Lunl/fct/di/fiddle_j/List_j;"
#define NEWTHREAD_J_SIG "Lunl/fct/di/fiddle_j/NewThread_j;"
#define POSITION_J_SIG "Lunl/fct/di/fiddle_j/Position_j;"
#define RUN_J_SIG "Lunl/fct/di/fiddle_j/Run_j;"
#define SENDTO_J_SIG "Lunl/fct/di/fiddle_j/Sendto_j;"
#define SIGNAL_J_SIG "Lunl/fct/di/fiddle_j/Signal_j;"
#define THREAD_J_SIG "Lunl/fct/di/fiddle_j/Thread_j;"
#define TIDS_J_SIG "Lunl/fct/di/fiddle_j/Tids_j;"
#define TKOUT_J_SIG "Lunl/fct/di/fiddle_j/Tkout_j;"

#define CHAIN_J_SIG "Lunl/fct/di/fiddle_j/util/Chain_j;"

#define FIDDLEEXCEPTION_SIG "Lunl/fct/di/fiddle_j/FiddleException;"
#define DEBUGGEREXCEPTION_SIG "Lunl/fct/di/fiddle_j/DebuggerException;"
#define SERVICENOTAVAILABLEEXCEPTION_SIG "Lunl/fct/di/fiddle_j/ServiceNotAvailableException;"

#else

#define ATTACH_J_SIG "LAttach_j;"
#define BPHIT_J_SIG "LBphit_j;"
#define BREAK_J_SIG "LBreak_j;"
#define CLIENTS_J_SIG "LClients_j;"
#define CODE_J_SIG "LCode_j;"
#define DATA_J_SIG "LData_j;"
#define DETACH_J_SIG "LDetach_j;"
#define DISPLAY_J_SIG "LDisplay_j;"
#define EVALUATE_J_SIG "LEvaluate_j;"
#define FRAME_J_SIG "LFrame_j;"
#define FILE_J_SIG "LFile_j;"
#define FINISH_J_SIG "LFinish_j;"
#define INFOBREAK_J_SIG "LInfobreak_j;"
#define INFOLINE_J_SIG "LInfoline_j;"
#define INFOPROGRAM_J_SIG "LInfoprogram_j;"
#define INFOTHREADS_J_SIG "LInfothreads_j;"
#define LIST_J_SIG "LList_j;"
#define NEWTHREAD_J_SIG "LNewThread_j;"
#define POSITION_J_SIG "LPosition_j;"
#define RUN_J_SIG "LRun_j;"
#define SENDTO_J_SIG "LSendto_j;"
#define SIGNAL_J_SIG "LSignal_j;"
#define THREAD_J_SIG "LThread_j;"
#define TIDS_J_SIG "LTids_j;"
#define TKOUT_J_SIG "LTkout_j;"

#define CHAIN_J_SIG "LChain_j;"

#define FIDDLEEXCEPTION_SIG "LFiddleException;"
#define DEBUGGEREXCEPTION_SIG "LDebuggerException;"
#define SERVICENOTAVAILABLEEXCEPTION_SIG "LServiceNotAvailableException;"

#endif

#define TRUE  1
#define FALSE 0
typedef char bool;

typedef struct {
  jint    tid;
  jstring str;
  jobject status;       /* jobject == Code_j  */
  jobject oob;          /* jobject == Chain_j */
  jobject pos;          /* jobject == Data_j  */
} _indOb_t, *indOb_t;

typedef struct {
  jobject rep;           /* jobject == Data_j  */
} _repOb_t, *repOb_t;


/*
 * Reports a fatal error, printing a message to the screen
 * and abruptly ending the program returning control to the
 * Operating System.
 * (+) msg, the error message to print to the screen;
 * (+) exitCode, the code with which to terminate the program;
 */
PUBLIC void fatalError(const char *msg, int exitCode);

/*fiddle_20010921-1648
 * Returns the signature string for a void method with
 * a string, code_j and chain_j arguments.
 * (+/-) buffer, the signature string;
 * (-) a pointer to the returned string.
 */
PUBLIC char *StrCodeChain_sigV(char *buffer);

/*
 * Constructs a Tkout_j with the given arguments.
 * (+) env, the JAVA enviroment functions;
 * (+) iObj, the independent objects;
 * (+) rObj, the reply object;
 * (-) a new Tkout_j.
 */
PUBLIC jobject initTkout_j(JNIEnv *env, indOb_t iObj, repOb_t rObj);

/*
 * Inserts a java object created in C into the rep member of the
 * current Tkout_j object.
 * (+) env, the JAVA runtime enviroment;
 * (+) javaObj, the java object to enqueue into the OoB list;
 * (+) rcvObj, the object on which to enqueue the java object.
 *             Must be a Data_j class object!
 */
PUBLIC void insertObjInJAVA(JNIEnv *env, jobject javaObj, jobject rcvObj);

#endif /* __COMMON_H_ */
