/* *****************************************************************
 *
 *  $Id: cmds.h,v 1.3 2002/09/27 12:43:03 jml Exp $
 *
 *  Copyright (c) 1999 by Dep.Informatica of the FCT/UNL
 *  Time-stamp: <02/09/22 00:20:38 jml>
 *
 *  Joao Lourenco <Joao.Lourenco@di.fct.unl.pt>
 *
 *  Parallel and Distributed Processing Group
 *  Departamento de Informatica
 *  Faculdade de Ciencias e Tecnologia
 *  Universidade Nova de Lisboa
 *
 * -----------------------------------------------------------------
 *
 *  Description:
 *
 * -----------------------------------------------------------------
 */
#ifndef __CMDS_H
#define __CMDS_H

#define fFIDDLE_LAYER 1


int my_atoi (const char *str);


tkout_t* cmd_help (int argc, const char *argv[]);
tkout_t* cmd_settid (int argc, const char *argv[]);
tkout_t* cmd_quit (int argc, const char *argv[]);
tkout_t* cmd_halt (int argc, const char *argv[]);
#ifndef f0s
tkout_t* cmd_signal (int argc, const char *argv[]);
#endif
tkout_t* cmd_tids (int argc, const char *argv[]);
tkout_t* cmd_add_debugger (int argc, const char *argv[]);
tkout_t* cmd_kill (int argc, const char *argv[]);
tkout_t* cmd_attach (int argc, const char *argv[]);
tkout_t* cmd_detach (int argc, const char *argv[]);
tkout_t* cmd_symbol_file (int argc, const char *argv[]);
tkout_t* cmd_file (int argc, const char *argv[]);
tkout_t* cmd_run (int argc, const char *argv[]);
tkout_t* cmd_step (int argc, const char *argv[]);
tkout_t* cmd_next (int argc, const char *argv[]);
tkout_t* cmd_continue (int argc, const char *argv[]);
tkout_t* cmd_finish (int argc, const char *argv[]);
tkout_t* cmd_call (int argc, const char *argv[]);
tkout_t* cmd_break (int argc, const char *argv[]);
tkout_t* cmd_delete (int argc, const char *argv[]);
tkout_t* cmd_tty (int argc, const char *argv[]);
tkout_t* cmd_set_variable (int argc, const char *argv[]);
tkout_t* cmd_call (int argc, const char *argv[]);
tkout_t* cmd_display (int argc, const char *argv[]);
tkout_t* cmd_undisplay (int argc, const char *argv[]);
tkout_t* cmd_evaluate (int argc, const char *argv[]);
tkout_t* cmd_list (int argc, const char *argv[]);
tkout_t* cmd_info_locals (int argc, const char *argv[]);
tkout_t* cmd_info_args (int argc, const char *argv[]);
tkout_t* cmd_info_line (int argc, const char *argv[]);
tkout_t* cmd_info_program (int argc, const char *argv[]);
tkout_t* cmd_info_stack (int argc, const char *argv[]);
tkout_t* cmd_up (int argc, const char *argv[]);
tkout_t* cmd_down (int argc, const char *argv[]);
tkout_t* cmd_frame (int argc, const char *argv[]);
tkout_t* cmd_info_break (int argc, const char *argv[]);
tkout_t* cmd_info_display (int argc, const char *argv[]);
tkout_t* cmd_info_threads (int argc, const char *argv[]);
tkout_t* cmd_thread (int argc, const char *argv[]);
tkout_t* cmd_sendto (int argc, const char *argv[]);
#if f2m || f3m
tkout_t* cmd_clients (int argc, const char *argv[]);
#endif



typedef tkout_t *CmdFunction_f (int argc, const char *argv[]);

typedef struct dbgcommand {
    CmdFunction_f	*cmd_funct;
	const char	    *cmd_delim;
    const char		*cmd_str;
    const char		*cmd_help1;
    const char		*cmd_help2;
} DbgCommand;


extern const DbgCommand cmd_table[];

#endif /* __CMDS_H */
