/* *****************************************************************
 *
 *  $Id: error.c,v 1.1.1.1 2002/04/28 22:06:57 jml Exp $
 *
 *  Copyright (c) 1999 by Dep.Informatica of the FCT/UNL
 *  Time-stamp: <00/10/23 17:00:25 jml>
 *
 *  Joao Lourenco <Joao.Lourenco@di.fct.unl.pt>
 *
 *  Parallel and Distributed Processing Group
 *  Departamento de Informatica
 *  Faculdade de Ciencias e Tecnologia
 *  Universidade Nova de Lisboa
 *
 * -----------------------------------------------------------------
 *
 *  Description:
 *
 * -----------------------------------------------------------------
 */

#include "error.h"
#include "config.h"

/* #################################################################
 *		#DEFINES, TYPES and GLOBAL (PRIVATE) VARIABLES
 * ################################################################# */



typedef struct cerrmsg {
	CErrCode   code;
	const char *msg;
} CErrMsg;


static CErrMsg c_err_tab[] = {
	{CE_NO_HELP,
	 "Command not found. No help available for this command."},
	{CE_INVALID_COMMAND,
	 "Invalid or ambiguous command.  Use \"help\" to get help."},
	{CE_INVALID_DBGID,
	 "Invlaid debugger identifier."},
	{CE_INVALID_NARGS,
	 "Invalid number of arguments.  Use \"help -s command\" to get help."},
	{CE_INVALID_ARGUMENT,
	 "Invalid command argument.  Use \"help -s command\" to get help."},
	{CE_INVALID_SYNTAX,
	 "Invalid command syntax.  Use \"help -s command\" to get help."},
	{CE_MISSING_TID,
	 "Missing \"tid\" specification.  Use \"help -s command\" to get help."},
	{0, "Unknown error code"}
};



/* #################################################################
 *		PRIVATE functions
 * ################################################################# */


/* #################################################################
 *		PUBLIC functions
 * ################################################################# */


const char *cons_err_msg (CErrCode code)
{
	int i;
	for (i = 0;  c_err_tab[i].code != 0;  i++)
		if (code == c_err_tab[i].code)
			break;
	return c_err_tab[i].msg;
}
